]> git.decadent.org.uk Git - nfs-utils.git/blobdiff - debian/nfs-common.init
Only use rpcbind's rpcinfo when it's available
[nfs-utils.git] / debian / nfs-common.init
old mode 100755 (executable)
new mode 100644 (file)
index 63bc29c..5e30d95
-#!/bin/sh
-#
-# nfs-common    This shell script takes care of starting and stopping
-#               common daemons required for NFS clients and servers.
+#!/bin/bash
+
+### BEGIN INIT INFO
+# Provides:          nfs-common
+# Required-Start:    $portmap $time
+# Required-Stop:     $time
+# Default-Start:     2 3 4 5 S
+# Default-Stop:      0 1 6
+# Short-Description: NFS support files common to client and server
+# Description:       NFS is a popular protocol for file sharing across
+#                   TCP/IP networks. This service provides various
+#                    support functions for NFS mounts.
+### END INIT INFO
+
+# What is this?
+DESC="NFS common utilities"
+
+# Read config
+DEFAULTFILE=/etc/default/nfs-common
+PREFIX=
+NEED_STATD=
+NEED_IDMAPD=
+NEED_GSSD=
+PIPEFS_MOUNTPOINT=/var/lib/nfs/rpc_pipefs
+RPCGSSDOPTS=
+if [ -f $DEFAULTFILE ]; then
+    . $DEFAULTFILE
+fi
+
+. /lib/lsb/init-functions
+
+# Exit if required binaries are missing.
+[ -x $PREFIX/sbin/rpc.statd ] || exit 0
+
 #
-# chkconfig: 345 20 80
-# description: NFS is a popular protocol for file sharing across \
-#             TCP/IP networks. This service provides NFS file \
-#             locking functionality.
+# Parse the fstab file, and determine whether we need idmapd and gssd. (The
+# /etc/defaults settings, if any, will override our autodetection.) This code
+# is partially adapted from the mountnfs.sh script in the sysvinit package.
 #
+AUTO_NEED_IDMAPD=no
+AUTO_NEED_GSSD=no
 
-PREFIX=
+if [ -f /etc/fstab ]; then
+    exec 9<&0 </etc/fstab
+
+    while read DEV MTPT FSTYPE OPTS REST
+    do
+       case $DEV in
+           ''|\#*)
+               continue
+               ;;
+       esac
+       # FSTYPE "nfs" can be NFSv4 now
+        #if [ "$FSTYPE" = "nfs4" ]; then
+            AUTO_NEED_IDMAPD=yes
+        #fi
+        case "$OPTS" in
 
-NEED_LOCKD=yes
-if test -f /proc/ksyms
-then
-    # We need to be conservative and run lockd,
-    # unless we can prove that it isn't required.
-    grep -q lockdctl /proc/ksyms || NEED_LOCKD=no
+            sec=krb5|*,sec=krb5|sec=krb5,*|*,sec=krb5i,*|sec=krb5i|*,sec=krb5i|sec=krb5i,*|*,sec=krb5i,*|sec=krb5p|*,sec=krb5p|sec=krb5p,*|*,sec=krb5p,*)
+           AUTO_NEED_GSSD=yes
+            ;;
+        esac
+    done
+
+    exec 0<&9 9<&-
 fi
 
-[ -x $PREFIX/sbin/rpc.statd ] || exit 0
-[ -x $PREFIX/sbin/rpc.lockd ] || [ "$NEED_LOCKD" = no ] || exit 0
+#
+# We also need idmapd if we run an NFSv4 server. It's fairly difficult
+# to autodetect whether there are NFSv4 exports or not, and idmapd is not a
+# particularily heavy daemon, so we auto-enable it if we find an /etc/exports
+# file. This does not mean that there are NFSv4 or other mounts active (or
+# even that nfs-kernel-server is installed), but it matches what the "start"
+# condition in nfs-kernel-server's init script does, which has a value in
+# itself.
+#
+if [ -f /etc/exports ] && grep -q '^[[:space:]]*[^#]*/' /etc/exports; then
+    AUTO_NEED_IDMAPD=yes
+fi
 
-# What is this?
-DESC="NFS common utilities"
+case "$NEED_STATD" in
+    yes|no)
+        ;;
+    *)
+        NEED_STATD=yes
+        ;;
+esac
+
+case "$NEED_IDMAPD" in
+    yes|no)    
+        ;;
+    *)
+        NEED_IDMAPD=$AUTO_NEED_IDMAPD
+       ;;
+esac
+
+case "$NEED_GSSD" in
+    yes|no)    
+        ;;
+    *)
+        NEED_GSSD=$AUTO_NEED_GSSD
+       ;;
+esac
+
+do_modprobe() {
+    if [ -x /sbin/modprobe -a -f /proc/modules ]
+    then
+        modprobe -q "$1" || true
+    fi
+}
 
-# Make sure that daemon cwds are in root fs.
-cd /
+do_mount() {
+    if ! grep -E -qs "$1\$" /proc/filesystems
+    then
+       return 1
+    fi
+    if ! mountpoint -q "$2"
+    then
+       mount -t "$1" "$1" "$2"
+       return
+    fi
+    return 0
+}
+
+do_umount() {
+    if mountpoint -q "$1"
+    then
+       umount "$1"
+    fi
+    return 0
+}
 
 # See how we were called.
 case "$1" in
   start)
-       printf "Starting $DESC:"
-       printf " statd"
-       start-stop-daemon --start --quiet \
-           --exec $PREFIX/sbin/rpc.statd
-       if [ "$NEED_LOCKD" = yes ]
+       log_daemon_msg "Starting $DESC"
+
+       if [ "$NEED_STATD" = yes ]; then
+           log_progress_msg "statd"
+           
+           # See if rpcbind is running
+           if [ -x /usr/sbin/rpcinfo ]; then
+               /usr/sbin/rpcinfo -p >/dev/null 2>&1
+               RET=$?
+               if [ $RET != 0 ]; then
+                  echo
+                  log_warning_msg "Not starting: portmapper is not running"
+                  exit 0
+               fi
+           fi
+           start-stop-daemon --start --oknodo --quiet \
+               --pidfile /var/run/rpc.statd.pid \
+               --exec $PREFIX/sbin/rpc.statd -- $STATDOPTS
+           RET=$?
+           if [ $RET != 0 ]; then
+               log_end_msg $RET
+               exit $RET
+           else
+               mkdir -p /lib/init/rw/sendsigs.omit.d
+               rm -f /lib/init/rw/sendsigs.omit.d/statd
+               ln -s /var/run/rpc.statd.pid /lib/init/rw/sendsigs.omit.d/statd
+           fi
+       fi
+
+       # Don't start idmapd and gssd if we don't have them (say, if /usr is not
+       # up yet).
+       [ -x /usr/sbin/rpc.idmapd ] || NEED_IDMAPD=no
+       [ -x /usr/sbin/rpc.gssd   ] || NEED_GSSD=no
+
+       if [ "$NEED_IDMAPD" = yes ] || [ "$NEED_GSSD" = yes ]
        then
-           printf " lockd"
-           start-stop-daemon --start --quiet \
-               --exec $PREFIX/sbin/rpc.lockd
+           do_modprobe sunrpc
+           do_modprobe nfs
+           do_modprobe nfsd
+           if do_mount rpc_pipefs $PIPEFS_MOUNTPOINT
+           then
+               if [ "$NEED_IDMAPD" = yes ]
+               then
+                   log_progress_msg "idmapd"
+                   start-stop-daemon --start --oknodo --quiet \
+                           --exec /usr/sbin/rpc.idmapd
+                   RET=$?
+                   if [ $RET != 0 ]; then
+                       log_end_msg $RET
+                       exit $RET
+                    fi
+               fi
+               if [ "$NEED_GSSD" = yes ]
+               then
+                   do_modprobe rpcsec_gss_krb5
+                   log_progress_msg "gssd"
+
+                   # we need this available; better to fail now than
+                   # mysteriously on the first mount
+                   if ! grep -q -E '^nfs[       ]' /etc/services; then
+                       log_action_end_msg 1 "broken /etc/services, please see /usr/share/doc/nfs-common/README.Debian.nfsv4"
+                       exit 1
+                   fi
+
+                   start-stop-daemon --start --oknodo --quiet \
+                           --exec /usr/sbin/rpc.gssd -- $RPCGSSDOPTS
+                   RET=$?
+                   if [ $RET != 0 ]; then
+                       log_end_msg $RET
+                       exit $RET
+                    fi
+               fi
+           fi
        fi
-       echo "."
+       log_end_msg 0
        ;;
 
   stop)
-       printf "Stopping $DESC:"
-       if [ "$NEED_LOCKD" = yes ]
+       log_daemon_msg "Stopping $DESC"
+
+       if [ "$NEED_GSSD" = yes ]
        then
-           printf " lockd"
+           log_progress_msg "gssd"
            start-stop-daemon --stop --oknodo --quiet \
-               --exec $PREFIX/sbin/rpc.lockd
+                   --name rpc.gssd
+           RET=$?
+           if [ $RET != 0 ]; then
+                log_end_msg $RET
+                exit $RET
+            fi
        fi
-       printf " statd"
-       start-stop-daemon --stop --oknodo --quiet \
-           --exec $PREFIX/sbin/rpc.statd
-       echo "."
+       if [ "$NEED_IDMAPD" = yes ]
+       then
+           log_progress_msg "idmapd"
+           start-stop-daemon --stop --oknodo --quiet \
+               --name rpc.idmapd
+            RET=$?
+           if [ $RET != 0 ]; then
+                log_end_msg $RET
+                exit $RET
+            fi
+       fi
+       if [ "$NEED_STATD" = yes ]
+       then
+           log_progress_msg "statd"
+           start-stop-daemon --stop --oknodo --quiet \
+               --name rpc.statd
+           RET=$?
+           if [ $RET != 0 ]; then
+                log_end_msg $RET
+                exit $RET
+            fi
+       fi
+       do_umount $PIPEFS_MOUNTPOINT 2>/dev/null || true
+       log_end_msg 0
+       ;;
+
+  status)
+       if [ "$NEED_STATD" = yes ]
+       then
+           if ! pidof rpc.statd >/dev/null
+           then
+               echo "rpc.statd not running"
+               exit 3
+           fi
+       fi
+
+       if [ "$NEED_GSSD" = yes ]
+       then
+            if ! pidof rpc.gssd >/dev/null
+           then
+               echo "rpc.gssd not running"
+               exit 3
+           fi
+       fi
+
+       if [ "$NEED_IDMAPD" = yes ]
+       then
+            if ! pidof rpc.idmapd >/dev/null
+           then
+               echo "rpc.idmapd not running"
+               exit 3
+           fi
+       fi
+
+       echo "all daemons running"
+       exit 0
        ;;
 
   restart | force-reload)
@@ -65,7 +289,7 @@ case "$1" in
        ;;
 
   *)
-       echo "Usage: nfs-common {start|stop|restart}"
+       log_success_msg "Usage: nfs-common {start|stop|status|restart}"
        exit 1
        ;;
 esac